unit Princ;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;
Const
  PixelCountMax = 32768;
  Red   :  TRGBTriple =
           (rgbtBlue: 0; rgbtGreen: 0; rgbtRed: 255);
  White :  TRGBTriple =
           (rgbtBlue: 255; rgbtGreen: 255; rgbtRed: 255);


Type
  pRGBTripleArray = ^TRGBTripleArray;
  TRGBTripleArray = ARRAY[0..PixelCountMax-1] OF TRGBTriple;

Type
  TF_Main = class(TForm)
    Label1: TLabel;
    E_NbRouge: TEdit;
    Label2: TLabel;
    E_NbForme: TEdit;
    Label3: TLabel;
    E_Surface: TEdit;
    Btn_Calcul: TButton;
    Label4: TLabel;
    E_NbBlanc: TEdit;
    Label5: TLabel;
    E_Taille: TEdit;
    E_Image: TEdit;
    Btn_Charger: TButton;
    Label6: TLabel;
    Btn_Fermer: TButton;
    PanelImage: TPanel;
    Image1: TImage;
    procedure Btn_CalculClick(Sender: TObject);
    Function  ColorToRGBTriple(CONST Color:  TColor):  TRGBTriple;
    Function  SameColor(Coul1 , Coul2 : TRGBTriple ): Boolean ;
    Function  IsWhite(Coul1 : TRGBTriple ; Tolerance : Integer ): Boolean ;
    procedure Btn_ChargerClick(Sender: TObject);
    procedure Btn_FermerClick(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  F_Main: TF_Main;

implementation

{$R *.dfm}

{ ===================================================================== }
procedure TF_Main.Btn_CalculClick(Sender: TObject);
Var
  i   :  Integer ;
  j   :  Integer ;
  Row :  pRGBTripleArray;
  BitMap  : TBitMap ;
  n1, n2  : Integer ;
  Taille  : Integer ;
  Surf    : Real ;
  Coul    : TRGBTriple ;
  Rouge , Blanc  : TRGBTriple ;
Begin
  if (not Assigned(Image1.Picture.Graphic)) or (Image1.Picture.Graphic.Empty) then
     Btn_ChargerClick(Self) ;
  n1   := 0 ;
  n2   := 0 ;
  Surf := 0 ;
  Rouge :=  ColorToRGBTriple(clRed) ;
  Blanc :=  ColorToRGBTriple(clWhite) ;
  Bitmap := TBitmap.Create;
  Try
    Bitmap.PixelFormat := pf24bit;
    Bitmap.Width  := Image1.Width;
    Bitmap.Height := Image1.Height;
    BitMap.Assign(Image1.Picture.Bitmap);
    Taille :=  Bitmap.Width * Bitmap.Height ;
    For j := 0 To Bitmap.Height-1 Do
    Begin
      Row := Bitmap.Scanline[j];
      For i := 0 To Bitmap.Width-1 Do
      Begin
        Coul := Row[i] ;
        If (SameColor(Coul, Rouge))   Then n2 := n2 + 1 ;
        If IsWhite(Coul, 5 )          Then n1 := n1 + 1 ;
      End
    End;
  Finally
    Bitmap.Free
  End ;
  If (n2 >0) Then  Surf := (Taille - n1 - n2) / n2
             Else  Surf := 999 ;
  E_Taille.Text   := IntToStr(Taille) ;
  E_NbBlanc.Text  := IntToStr(n1) ;
  E_NbRouge.Text  := IntToStr(n2) ;
  E_NbForme.Text  := IntToStr(Taille - n1 - n2) ;
  E_Surface.Text  := Format('%8.2f', [Surf]);
end;
{ ===================================================================== }
Function  TF_Main.ColorToRGBTriple(CONST Color:  TColor):  TRGBTriple;
Begin
  With Result Do
  Begin
    rgbtRed   := GetRValue(Color);
    rgbtGreen := GetGValue(Color);
    rgbtBlue  := GetBValue(Color)
  End
End ;     
{ ===================================================================== }
Function  TF_Main.SameColor(Coul1 , Coul2 : TRGBTriple ): Boolean ;
Begin
  Result := False ;
  If (Coul1.rgbtBlue  <> Coul2.rgbtBlue) Then Exit ;
  If (Coul1.rgbtGreen <> Coul2.rgbtGreen) Then Exit ;
  If (Coul1.rgbtRed   <> Coul2.rgbtRed) Then Exit ;
  Result := True ;
End ;
{ ===================================================================== }
Function  TF_Main.IsWhite(Coul1 : TRGBTriple ; Tolerance : Integer ): Boolean ;
Begin
  Result := False ;
  If (Coul1.rgbtBlue  < (255 - Tolerance)) Then Exit ;
  If (Coul1.rgbtGreen < (255 - Tolerance)) Then Exit ;
  If (Coul1.rgbtRed   < (255 - Tolerance)) Then Exit ;
  Result := True ;     
End ;
{ ===================================================================== }
procedure TF_Main.Btn_ChargerClick(Sender: TObject);
begin
  If FileExists(E_Image.Text) Then
     Image1.Picture.LoadFromFile(E_Image.text);
end;
{ ===================================================================== }
procedure TF_Main.Btn_FermerClick(Sender: TObject);
begin
  Close ;
end;
{ ===================================================================== }
end.
